from yocto_api import *
from yocto_anbutton import *
from pyaxidraw import axidraw   

# middle of the sheet
Xorigin = 150
Yorigin = 100
# scanning zone size
dx= 38
dy= 26

errmsg = YRefParam()

# Setup the API to use local USB devices
if YAPI.RegisterHub("127.0.0.1", errmsg) != YAPI.SUCCESS:
    sys.exit("init error" + errmsg.value)

# find the first Yocto-Knob inpout
channel = YAnButton.FirstAnButton()
if channel is None:
    sys.exit("No Yocto-Knob Found" )
module = channel.get_module();
bt = YAnButton.FindAnButton(module.get_serialNumber()+".anButton1");

# draw an align line
ad = axidraw.AxiDraw()   #init axidraw
ad.interactive()
ad.connect()
ad.options.units = 2
ad.moveto(Xorigin-75,Yorigin+38)
ad.lineto(Xorigin+75,Yorigin+38)
ad.moveto(Xorigin,Yorigin)
input("Press Enter to continue...")

# start scanning
lastWasOn = False
if True:
 for i in range(0,2*dx):
  lastWasOn = False
  for j in range(0,dy):
    x =  Xorigin+i-dx
    y =  Yorigin-j
    if (lastWasOn):
         ad.lineto(x,y)
    else:
         ad.moveto(x,y)
    YAPI.Sleep(10)
    lastWasOn=  bt.get_isPressed()


# Done
ad.moveto(0,0)
ad.disconnect()                 # Close serial port to AxiDraw